% Set the upper bound on dt:
% Sometimes this is useful when starting with very small perturbations,
% or when a diffusion adds a limit to dt

% First, set a time-step constraint based on diffusion
dt=0.5*min(min(min(DX(ii,jj),DY(ii,jj))))/max(1/Re,1/Re/PR);

dt_x=CFL*min(min(DX(ii,jj)./abs(U1(ii,jj))));
dt_y=CFL*min(min(DY(3:NX-1,3:NY-1)./abs(U2(3:NX-1,3:NY-1))));  % Avoid j=2 which is a ghost cell

dt=min([dt dt_x dt_y]);

if (dt<=0)  error('DT<=0 in courant'); end;

% Set the size of the timestep (DELTA_T), and the RK substeps (H_BAR)
DELTA_T=dt;
H_BAR(1)=DELTA_T*(8/15);
H_BAR(2)=DELTA_T*(2/15);
H_BAR(3)=DELTA_T*(5/15);

