% This script creates a new flow field
% We need to initialize U1, U2, U3, TH and P

% Since we are starting with a new flow, set TIME_STEP=0
% If you are continuing an existing simulation, don't do this (unless you want to reset the timestep)
TIME_STEP=0;

U1=zeros(NX,NY); % U1 is the velocity in the X direction
U2=zeros(NX,NY); % U2 is the velocity in the Y direction
U3=zeros(NX,NY); % U3 is the velocity in the Z direction
P=zeros(NX,NY); % P is the pressure
PHI=zeros(NX,NY); % PHI is a temporary variable used to make the velocity divergence free

TH=zeros(NX,NY,1:N_TH);

% Start with an unstable buoyancy field for Rayleigh-Taylor instability
interface_width=1/20;
for i=1:NX
for j=1:NY
  TH(i,j,:)=-1*tanh((GYF(j)-LY/2)/interface_width);
end
end

% Add a random perturbation to the velocity
U1=U1+0.1*(rand(NX,NY)-0.5);
U2=U2+0.1*(rand(NX,NY)-0.5);



